<template lang="html">
  <div class="text-field">
    <butter-icon v-if="dirty && !loading" class="clear" name="close" @click.native="clear" />
    <loading-dots v-else-if="loading" class="loading" />
    <form-field v-bind="$props" :error="internalError" :value="internal" ref="form-field">
      <input ref="input" :type="type" :placeholder="placeholder" :name="name" v-model="internal" @blur="onBlur($event)" @focus="onFocus($event)" :disabled="disabled" />
    </form-field>
  </div>
</template>

<script>
import { EVENT_INPUT, EVENT_BLUR, EVENT_FOCUS } from '../lib/events'
export default {
  props: {
    'label': String,
    'note': String,
    'placeholder': String,
    'value': String,
    'error': String,
    'validator': {
      required: false,
      default: null,
    },
    'invalidMessage': {
      required: false,
      default: '',
    },
    'type': {
      type: String,
      default: 'text',
    },
    'name': {
      type: String,
      default: 'text',
    },
    'disabled': {
      type: Boolean,
      default: false,
    },
    'inputDelay': {
      type: Number,
      default: 0
    }
  },
  data() {
    return {
      internal: this.value,
      internalError: this.error,
      loading: false,
      throttled: null,
    };
  },
  computed: {
    dirty() {
      return this.value && this.value.length && !this.disabled
    }
  },
  methods: {
    clear() {
      this.internal = '';
      this.$emit(EVENT_INPUT,'');
      this.$refs['form-field'].hasContent = false;
      this.$refs['form-field'].hasFocus = false;
    },
    onBlur(event) {
      this.$emit(EVENT_BLUR,event);

      this.internalError = this.validationError(this.internal);

      /* HACK: This is a hack for a bug in xcode causing hit areas to shift after the keyboard is closed */
      window.scrollTo(0,0);
      window.scrollTo(0,this.inputYoffset);
    },
    onFocus(event) {
      this.$emit(EVENT_FOCUS,event);
      this.inputYoffset = window.pageYOffset;
    },
    focus() {
      this.$refs['input'].focus();
    },
    validationError(value) {
      const validator = this.validator;

      if(validator) {
        if(typeof validator == 'function')
          return validator(value);
        if(typeof validator.test == 'function') {
          if(!validator.test(this.internal)) return this.invalidMessage;
          return null;
        }
      }

      return null;
    },
    throttle(func, ms) {
      if (this.throttled) {
        clearTimeout(this.throttled)
      }
      this.throttled = setTimeout(func, ms)
    },
  },
  watch: {
    error(value) {
      this.internalError = value;
    },
    value(value) {
      if((value === null || value === '') && this.validationError(this.internal)) {
        return;
      }

      this.internal = value;
    },
    internal(value) {
      this.internalError = null;
      if(!this.validationError(value)) {
        if (!this.inputDelay) {
          this.$emit(EVENT_INPUT, value)
        } else {
          this.loading = true
          this.throttle(function () {
            this.$emit(EVENT_INPUT, value)
            this.loading = false
          }.bind(this), this.inputDelay)
        }
      } else {
        this.$emit(EVENT_INPUT,null);
      }
    }
  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';

.text-field {
  position: relative;
  padding: $grid;
}
.text-field input::-webkit-outer-spin-button,
.text-field input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
.text-field .clear,
.text-field .loading {
  @include themify($themes) {
    fill: themed('color-text-inactive');
  }
  position: absolute;
  top: $grid * 2;
  right: $grid * 2;
  z-index: 9;
}
</style>
